#include "thermonew.h"
#define LCD_MAIN 1
#include "lcdisplay.h"

#define LCDserial1 Serial1
#define LCDserial2 Serial2
#define LCDserial3 Serial3
// #define LCDserial4 Serial

//
//  LCD display routines
//

void LCDbacklight (unsigned char zone, unsigned int intensity) {
HardwareSerial *hsp;
char buf[4];
    hsp = LCDportarray[zone];
    (*hsp).print("?B");   // backlight intensity
    sprintf(buf, "%02X", intensity);
    (*hsp).print(buf);
}

// define a "degree" symbol as character "?0"
void defineDEGsym (unsigned char zone) {
HardwareSerial *hsp;
    hsp = LCDportarray[zone];
    (*hsp).print("?D0040A040000000000");   // special character 0
}

void setupLCD (void) {
HardwareSerial *hsp;
unsigned char zone;
    for(zone = 0 ; zone < MAXZONES ; zone++) {
	hsp = LCDportarray[zone];
	(*hsp).begin(9600);
	LCDbacklight(zone, (unsigned int)zone_config[zone].backlight);
	defineDEGsym(zone);
	delay(100);
	(*hsp).print("?c0");    // No Cursor
	(*hsp).print("?G");	// sends "?G216" for 2x16 display
	(*hsp).print((int)(zone_config[zone].rows));
	(*hsp).print((int)(zone_config[zone].cols));
	(*hsp).print("?f");     //clear command.
	delay(100);
    }
}

void LCDline (unsigned char zone, unsigned char line) {
HardwareSerial *hsp;
    hsp = LCDportarray[zone];
    (*hsp).print("?y");   //Row #
    (*hsp).print((int)line);
    (*hsp).print("?x00");    //Column 0
}
