#include "thermonew.h"
#define NTP_MAIN 1
#include "ntpstuff.h"

void (* resetFunc2) (void);
/*-------- NTP code ----------*/

const int NTP_PACKET_SIZE = 48; // NTP time is in the first 48 bytes of message
byte packetBuffer[NTP_PACKET_SIZE]; //buffer to hold incoming & outgoing packets

time_t getNtpTime(void) {
time_t result;
int j, bad_date_retries;
char ntpserver[30];

    bad_date_retries = 3;
Retry:
    while (Udp.parsePacket() > 0) ; // discard any previously received packets
    for(j = 0 ; j < ((dns_working) ? 8 : 3) ; j++)
    {
#if NTPDEBUG
	DLFn("before sendNTPpacket()");
#endif
	if(dns_working) {
	    if(j == 0) {
		strcpy_P(ntpserver, PSTR("pool.ntp.org"));
	    }
	    else if(j == 1) {
		strcpy_P(ntpserver, PSTR("time-a.timefreq.bldrdoc.gov"));
	    }
	    else if(j == 2) {
		strcpy_P(ntpserver, PSTR("time-b.timefreq.bldrdoc.gov"));
	    }
	    else if(j == 3) {
		strcpy_P(ntpserver, PSTR("time-c.timefreq.bldrdoc.gov"));
	    }
	    else if(j == 4) {
		strcpy_P(ntpserver, PSTR("0.ubuntu.pool.ntp.org"));
	    }
	    else if(j == 5) {
		strcpy_P(ntpserver, PSTR("1.ubuntu.pool.ntp.org"));
	    }
	    else if(j == 6) {
		strcpy_P(ntpserver, PSTR("2.ubuntu.pool.ntp.org"));
	    }
	    else if(j == 7) {
		strcpy_P(ntpserver, PSTR("3.ubuntu.pool.ntp.org"));
	    }
	    DVFn("NTP Req ", ntpserver);
	    sendNTPpacket(ntpserver);
	}
	else {
	    if(j == 0) {
		IPAddress addr = (132, 163, 4, 101); // time-a.timefreq.bldrdoc.gov
		DVFn("NTP Req ", "132.163.4.101");
		sendNTPpacketAddr(addr);;
	    }
	    else if(j == 1) {
		DVFn("NTP Req ", "132.163.4.102");
		IPAddress addr = (132, 163, 4, 102); // time-b.timefreq.bldrdoc.gov
		sendNTPpacketAddr(addr);;
	    }
	    else if(j == 2) {
		DVFn("NTP Req ", "132.163.4.103");
		IPAddress addr = (132, 163, 4, 103); // time-c.timefreq.bldrdoc.gov
		sendNTPpacketAddr(addr);;
	    }
	}
#if NTPDEBUG
	DLFn("after sendNTPpacket()");
#endif
	uint32_t beginWait = millis();
	// DVn("beginWait ", beginWait);
	while (millis() - beginWait < 1500) {
	    // DVn("millis() ", millis());
	    int size = Udp.parsePacket();
	    if (size >= NTP_PACKET_SIZE) {
#if NTPDEBUG
		Serial.println(F("Receive NTP Response"));
#endif
		Udp.read(packetBuffer, NTP_PACKET_SIZE);  // read packet into the buffer
		unsigned long secsSince1900;
		// convert four bytes starting at location 40 to a long integer
		secsSince1900 =  (unsigned long)packetBuffer[40] << 24;
		secsSince1900 |= (unsigned long)packetBuffer[41] << 16;
		secsSince1900 |= (unsigned long)packetBuffer[42] << 8;
		secsSince1900 |= (unsigned long)packetBuffer[43];
		result = secsSince1900 - 2208988800UL;
		// result = secsSince1900 - 2208988800UL + timeZone * SECS_PER_HOUR;
		// if(month(result) >3 && month(result) < 11) {
		  // result = secsSince1900 - 2208988800UL + (timeZone + 1) * SECS_PER_HOUR;
		// }
		DVFn("time_t = ", result);
		DVFn("year is ", (int)year(result));
		if(year(result) > 2035 || year(result) < 2014) {
		    DVFn("bad date detected: ", (int)year(result));
		    bad_date_retries++;
		    goto Retry;
		}
		return (result);
	    }
	}
#if NTPDEBUG
	Serial.print(F("NTP timeout"));
	DVFn(", j = ", j);
	delay(2000);
#endif
    }
#if NTPDEBUG
    Serial.println(F("No NTP Response :-("));
#endif
    if(!startup_delay) {
  	resetFunc2();
    }
    return 0; // return 0 if unable to get the time
}

// send an NTP request to the time server at the given host
void sendNTPpacket(char *host) {
  // set all bytes in the buffer to 0
  memset(packetBuffer, 0, NTP_PACKET_SIZE);
  // Initialize values needed to form NTP request
  // (see URL above for details on the packets)
  packetBuffer[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer[1] = 0;     // Stratum, or type of clock
  packetBuffer[2] = 6;     // Polling Interval
  packetBuffer[3] = 0xEC;  // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer[12]  = 49;
  packetBuffer[13]  = 0x4E;
  packetBuffer[14]  = 49;
  packetBuffer[15]  = 52;
  // all NTP fields have been given values, now
  // you can send a packet requesting a timestamp:
#if NTPDEBUG
  DLFn("before Udp.beginPacket()");
#endif
  Udp.beginPacket(host, 123); //NTP requests are to port 123
#if NTPDEBUG
  DLFn("before Udp.write()");
#endif
  Udp.write(packetBuffer, NTP_PACKET_SIZE);
#if NTPDEBUG
  DLFn("before Udp.endPacket()");
#endif
  Udp.endPacket();
}

// send an NTP request to the time server at the given address
void sendNTPpacketAddr(IPAddress &host) {
  // set all bytes in the buffer to 0
  memset(packetBuffer, 0, NTP_PACKET_SIZE);
  // Initialize values needed to form NTP request
  // (see URL above for details on the packets)
  packetBuffer[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer[1] = 0;     // Stratum, or type of clock
  packetBuffer[2] = 6;     // Polling Interval
  packetBuffer[3] = 0xEC;  // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer[12]  = 49;
  packetBuffer[13]  = 0x4E;
  packetBuffer[14]  = 49;
  packetBuffer[15]  = 52;
  // all NTP fields have been given values, now
  // you can send a packet requesting a timestamp:
#if NTPDEBUG
  DLFn("before Udp.beginPacket()");
#endif
  Udp.beginPacket(host, 123); //NTP requests are to port 123
#if NTPDEBUG
  DLFn("before Udp.write()");
#endif
  Udp.write(packetBuffer, NTP_PACKET_SIZE);
#if NTPDEBUG
  DLFn("before Udp.endPacket()");
#endif
  Udp.endPacket();
}
